/*
    NullBot Robot Client 

    (C) 2005-2011 Jason Hunt

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com
    
*/


#include <windows.h>

#include "types.h"
#include "profile.h"

#include "utility.h"
#include "config.h"
#include "main.h"

#define MODULE_NAME "[Profile] "

/* Profile constructor, link to main */
profile_class::profile_class ( main_class *m )
{
    start_time = 0;
    ave = 0;
    alpha = 0.01;

    main_link = m;
}
/* End of profile_class::profile_class */



/* Start timer, s is number of steps to skip  */
void profile_class::start( unsigned int s )
{
    step = s;
    
    if (main_link == NULL) return;
    
    start_time = get_time();
}
/* End of profile_class::start */


/* Stop timer with message */
void profile_class::stop( char * m )
{
    if (main_link == NULL) return;

    double diff = get_time() - start_time;
       
    ave = alpha * diff + (1 - alpha) * ave;

    if (count++ < step) return;
    
    count = 0;

    main_link->alert(MODULE_NAME "%s  Ave: %f ms", m, ave * 1000);
}
/* End of  profile_class::stop */












