/*
    NullBot Robot Platform - Server - 2005-2011 Jason Hunt
    
    GNU GENERAL PUBLIC LICENSE Version 2, June 1991
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com
    
    File: camera_drv.h
*/

#ifndef CAMERA_DRV_H
#define CAMERA_DRV_H

#include "utility.h"

#include <linux/videodev.h>
#include <pthread.h>



#define CLEAR(x) memset (&(x), 0, sizeof (x))



struct buffer 
{
    void   *start;
    size_t length;
};




typedef struct 
{
    int camera_server_sd;  
    int camera_client_connected;

    struct video_mbuf mbuf;
    struct video_mmap vid_buffer;

    unsigned int image_x;
    unsigned int image_y;

    pthread_t camera_t;

    unsigned char *camera_buff;
    unsigned int max_image;

    unsigned int save_image;
    unsigned int save_count;

    int port;

    char dev_name[256];

    int fd ;
    struct buffer *buffers;
    unsigned int n_buffers;
    
    int req_x;
    int req_y;
    

} camera_type;


int cameradrv_start (camera_type *camera);
void cameradrv_stop (camera_type *camera);

void cameradrv_frame (camera_type *camera, unsigned char *data, unsigned int max, unsigned int *len);

#endif
