/*
    NullBot Robot Platform - Server - 2005-2011 Jason Hunt
    
    GNU GENERAL PUBLIC LICENSE Version 2, June 1991
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com
    
    File: failsafe.c
*/

#include <pthread.h>
#include <stdio.h>
#include <unistd.h>
#include <termios.h> 

#include "utility.h"
#include "server.h"
#include "failsafe.h"
#include "robot.h"
#include "network.h"
#include "serial.h"

#define MODULE_NAME "[Failsafe] "

int failsafe_running = 0;

pthread_t failsafe_t;
 
 int transmit = 0;
 

/* reset controller if the connection fails */
void *failsafe(void *id)
{
    failsafe_running = 1;

    alert(MODULE_NAME "Started\n");
    
    while(!program_done)
    {
        usleep(CHECK_PERIOD);

    alert(MODULE_NAME "Rate: %d kb/sec\n", transmit * 8 / 1000);

    transmit = 0;

        if (!robot_check_serial())
        {
            // avoid adding to flush if we are already flushing
            if (serial_flushing() == 0)
            {
              //  alert(MODULE_NAME "No controller data, flush\n");

               // robot_flush();

                //controller_flush = 15;    
            }
        }

        if (network_connected())
        {
            if (!robot_check_client())
            {
                alert(MODULE_NAME "No client update, reset\n");
                robot_reset();
               
               // connected = 0;
            }
        }
    }
    
    alert(MODULE_NAME "Shutdown\n");    
    
    pthread_exit(NULL); // exit thread
}
/* End of failsafe */


/* Start failsafe */
void failsafe_start( void )
{
    // start the failsafe
    pthread_create(&failsafe_t, NULL, failsafe, NULL);

}
/* End of failsafe_start */


/* Stop failsafe */
void failsafe_stop( void )
{


}
/* End of failsafe stop */







