/********************************************************
battery.c 
copyright (c) 2010-2011,  Russell K. Davis
all rights reserved.
 * *****************************************************/


#include <linux/i2c-dev.h>
#include <linux/i2c.h>

#include <fcntl.h>

#include <signal.h>


#include <stdio.h>
#include <stdlib.h>


unsigned int program_done = 0;




/* Hangle signals */
void sighandler(int sig)
{
        program_done = 1;
}
/* End of sighandler */
        

#define I2C_ADDR 0x41


#define packet_len      1
  

int main(int argc, char **argv) 
{
    signal(SIGABRT, &sighandler);
    signal(SIGTERM, &sighandler);
    signal(SIGINT, &sighandler);
    
    int fd;

    int adapter_nr = 0; /* probably dynamically determined */

    char filename[20];
	  
    snprintf(filename, 19, "/dev/i2c-%d", adapter_nr);

    fd = open(filename, O_RDWR);
	  
	  
    if (fd< 0) 
    {
        /* ERROR HANDLING; you can check errno to see what went wrong */
	    exit(1);
    }

    int addr = I2C_ADDR; /* The I2C address */
	
    if (ioctl(fd, I2C_SLAVE, addr) < 0) 
    {
	   /* ERROR HANDLING; you can check errno to see what went wrong */
	   close(fd);
        
	   exit(1);
    }

//if (flush(fd))
{
//printf("Unable to flush\n");
//exit(1);
}



        char rx_buff[packet_len];
        
        
        unsigned int i;
        

    read(fd, rx_buff, packet_len);

usleep(1500000);

    while(!program_done)
    {
        char buf[10];
  
        buf[0] = 7;
        buf[1] = 1;
        buf[2] = 0x80;
        buf[3] = 0x80;
        buf[4] = 0x80;
        buf[5] = 0x80;
        buf[6] = 0x08;
        
        
        unsigned int len = 7;
  
        printf("Write: %x\n", buf[0]);
	    
        if (write(fd, buf, len) != len) 
        {
            printf("Write failed\n");
        
            /* ERROR HANDLING: i2c transaction failed */
        }



        unsigned int l = 17;

        for (i = 0; i < l; i++)
{
	
        /* Using I2C Read, equivalent of i2c_smbus_read_byte(file) */

unsigned char c = read(fd, rx_buff, packet_len );

 
        {
            unsigned int i;
        
//            printf(" ");


            
            for (i = 0; i < c; i++)
                   printf("%2x ", rx_buff[i]);

           if (packet_len > 1)
               printf("\n");
                   
//            printf("  ");
                   
        }
        
//usleep(10000);    
        }
        
        printf("\n");
        

//        sleep(1);
    }

    printf("Program Exit\n");    

    close(fd);
    
    return 0;


}

