
/*
    NullBot Robot Platform - Server - 2005-2011 Jason Hunt
    
    GNU GENERAL PUBLIC LICENSE Version 2, June 1991
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com
    
    File: process.h
*/

#ifndef PROCESS_H
#define PROCESS_H
#define BYTE unsigned char


#include "camera_drv.h"


typedef struct tagJPGFILEHEADER 
{
	BYTE SOI[2];           /*SOI Marker 0xFFD8*/
	BYTE APP0[2];          /*APP0 MARKER 0xFF0E*/
	BYTE length[2];        /*length of header without APP0 in bytes*/
	BYTE JFIF[5];          /*set to JFIF0 0x4A46494600*/
	BYTE VERS[2];          /*1-2 0x0102*/
	BYTE density;          /* 0 - No units, aspect ratio only specified
            		        1 - Pixels per Inch on quickcam5000pro
                			2 - Pixels per Centimetre                */
	BYTE xdensity[2];      /*120 on quickcam5000pro*/
	BYTE ydensity[2];      /*120 on quickcam5000pro*/
	BYTE WTN;              /*width Thumbnail 0*/
	BYTE HTN;              /*height Thumbnail 0*/	
} __attribute__ ((packed)) JPGFILEHEADER, *PJPGFILEHEADER;



// Code adapted from guvcview
void process_image(camera_type *camera, unsigned char *image_in, 
                                        unsigned char *image_out, 
                                        unsigned int in_len, 
                                        unsigned int *out_len);
                          
                          
#endif



