/*
	NullBot Robot Platform - NodeIO - 2005-2011 Jason Hunt

	Contact: nulluser@gmail.com
    
	GNU GENERAL PUBLIC LICENSE Version 2, June 1991
	
	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	File: i2c.c
*/



/*
	This code is exprimental
*/


#include "core.h"
#include "i2c.h" 


#ifdef I2CHOST

#define I2C_NONE	0
#define I2C_WRITE	1
#define I2C_READ	2


unsigned char i2c_state = I2C_NONE;
unsigned char rx_index = 0;


void i2c_write(unsigned char b)
{
	while(I2CSTATbits.TBF); 

	I2CSTATbits.IWCOL = 0;

	// Re-transmit in case of collision
	do
		I2CTRN  = b;   
	while (I2CSTATbits.IWCOL);


	I2CCONbits.SCLREL = 1;
//	while(I2CSTATbits.TBF); 
}


unsigned char i2c_read( void )
{
//	unsigned char d;
	//d = I2CRCV;
	//return d;

	while(!I2CSTATbits.RBF);
	I2CSTATbits.I2COV = 0;
	return(I2CRCV);
}



void i2c_read_next( void )
{
//	unsigned char data = i2c_read();
	//process_host_tx(data);
}

unsigned int count = 0;

void i2c_write_next( void )
{
	if (tel_index == 0)
	{
		controller_telemetry();
		count++;

	}


	i2c_write(tel_packet[tel_index]);


//	i2c_write(count);
	//i2c_write(tel_index++);
		

	if (++tel_index >= COMM_IN_TEL_LEN+3)
		tel_index = 0;

}


unsigned char SlaveReadI2C1(void)
{
     while(!I2CSTATbits.RBF);
     I2CSTATbits.I2COV = 0;
     return(I2CRCV);

}

void SlaveWriteI2C1(unsigned char data_out)
{
     I2CTRN = data_out;      /* data transferred to I2C1TRN reg */
     I2CCONbits.SCLREL = 1;	/* Release the clock */
}



//  Main data from the host
void __attribute__((__interrupt__, auto_psv)) _SI2CInterrupt (void)
{




/*


	unsigned char temp; 
	static unsigned int dIndex; 
	 


	 
	// handle the incoming message 
	if ((I2CSTATbits.R_W == 0) && (I2CSTATbits.D_A == 0)) 
{ 
		// reset any state variables needed by a message sequence	 
		// perform a dummy read 
		temp = SlaveReadI2C1(); 
		I2CCONbits.SCLREL = 1; // release the clock 
	} else 
	

	if ((I2CSTATbits.R_W == 0) && (I2CSTATbits.D_A == 1)) 
	{ 
		// writing data to our module, just store it in adcSample 
		temp= SlaveReadI2C1(); 
		I2CCONbits.SCLREL = 1; // release clock stretch bit 
	} else 
	
	if ((I2CSTATbits.R_W == 1) && (I2CSTATbits.D_A == 0)) 
	{ 
		// read of the slave device, read the address  
		temp = SlaveReadI2C1(); 
		dIndex = 0; 


		SlaveWriteI2C(tel_index++); 


	} else 

	if ((I2CSTATbits.R_W == 1) && (I2CSTATbits.D_A == 1)) 
	{		 
		// output the data until the MASTER terminates the 
		// transfer with a NACK, continuing reads return 0 
		if (dIndex == 0) 
		{ 
			SlaveWriteI2C(tel_index++); 
			dIndex++; 
		} else 
			SlaveWriteI2C(0); 
		 
	} 
	 
	// finally clear the slave interrupt flag 
	//mI2C1SClearIntFlag();




I2CCONbits.SCLREL = 1;

IFS0bits.SI2CIF=0;



*/







if (IFS0bits.MI2CIF)
{
IFS0bits.MI2CIF = 0;
return;
}











	unsigned char data;




	if (I2CSTATbits.I2COV)
	{
		I2CCONbits.SCLREL = 1;
		I2CSTATbits.I2COV = 0;
		data = I2CRCV;
//blink_enable = 0;


	} else






	if(I2CSTATbits.S)
	{


//	data = I2CRCV;


		// Master write
		if (!I2CSTATbits.R_W)// && !I2CSTATbits.RBF)
		{
			data = I2CRCV;

			// Master write, Last byte was data
			if (I2CSTATbits.D_A)
			{
				process_host_rx (data );

			


			} else
			// Master write, Last byte was address
			{
			
			} 
	
		} 

		// Read mode
		// I2CCONbits.SCLREL is 1 after a NACK, do not reply
		if (I2CSTATbits.R_W )
		{

		if((I2CCONbits.SCLREL ==1))
		{	
			// Last byte was data
			if (I2CSTATbits.D_A)
			{
				i2c_write_next();

			//	I2CCONbits.SCLREL = 1;
			} else
			//Last byte was an address
			{
			//	if (I2CSTATbits.RBF)
			//		i2c_write_next();
				data = I2CRCV;
				i2c_write_next();
			} 
		} //else
		//	i2c_write(0x00);

		}

	


	}




	IFS0bits.SI2CIF=0;

	I2CCONbits.SCLREL = 1;

}
/* End of  */


#endif


/* Init the I2C module */
void i2c_init( void )
{
#ifdef I2CHOST

	I2CCONbits.I2CEN = 1;
	I2CADD = I2C_ADDR;

	//	I2CCONbits.STREN = 1;

	I2CCONbits.RCEN = 1;
	//	I2CCONbits.SMEN = 1; //check
	//	I2CCONbits.DISSLW = 1;

	//	I2CCONbits.GCEN = 1;

	I2CCONbits.DISSLW = 1;  // Slew rate control disabled
	I2CCONbits.STREN = 1;		// CLock strech enable
	//I2CCONbits.ACKDT = 1;

	IPC3bits.SI2CIP = 7 ; 
    IFS0bits.SI2CIF = 0 ; 
    IEC0bits.SI2CIE = 1 ;

#endif
}
/* End of i2c_init */











